com.smartgwt.client.widgets

## Class Dialog

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.layout.VLayout
            - - com.smartgwt.client.widgets.Window
              - - com.smartgwt.client.widgets.Dialog

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasButtonClickHandlers, HasClearHandlers, HasClickHandlers, HasCloseClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMaximizeClickHandlers, HasMinimizeClickHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRestoreClickHandlers, HasRightMouseDownHandlers, HasRuleContextChangedHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers, HasMembersChangedHandlers

      public class Dialog
      extends Window
      implements HasButtonClickHandlers

  Dialogs are a specialized version of `Window` used for small windows that contain just a text message or a text mesage with some standard buttons.

  Many typical modal dialogs such as alerts and confirmations are built into the system with convenience APIs - see `isc.say()`, `isc.warn()` and `isc.askForValue()`.

  Dialogs can be modal or non-modal according to `isModal`.

  NOTE: If you are building a dialog that will involve more than just buttons and a message, consider starting from the `Window` class instead, where arbitrary components can be added to the body area via `Window.addItem()`.

  This is an example of creating a custom dialog:

        final Dialog dialog = new Dialog();
        dialog.setMessage("Please choose whether to proceed");
        dialog.setIcon("[SKIN]ask.png");
        dialog.setButtons(new Button("OK"), new Button("Cancel"));
        dialog.addButtonClickHandler(new ButtonClickHandler() {
            public void onButtonClick(ButtonClickEvent event) {
                dialog.hide();
            }
        });
        dialog.draw();

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static Button` | `APPLY` APPLY Button object.
    `static Button` | `CANCEL` CANCEL Button object.
    `static Button` | `DONE` DONE Button object.
    `static Button` | `NO` NO Button object.
    `static Button` | `OK` OK Button object.
    `static Button` | `YES` YES Button object.

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Dialog()`
    `Dialog(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.event.shared.HandlerRegistration` | `addButtonClickHandler(ButtonClickHandler handler)` Add a buttonClick handler.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `java.lang.String` | `getAskIcon()` Icon to show in the `SC.ask()` dialog.
    `java.lang.Boolean` | `getAutoFocus()` If a toolbar is showing, automatically place keyboard focus in the first button.
    `java.lang.String` | `getConfirmIcon()` Icon to show in the `SC.confirm()` dialog.
    `int` | `getDefaultWidth()` For custom components, establishes a default width for the component.
    `java.lang.String` | `getIcon()` Icon to show in this dialog - see `message`.
    `int` | `getIconSize()` Size of the icon to show in this dialog.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()` Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `java.lang.String` | `getMessage()` Message to show in this dialog.
    `Img` | `getMessageIcon()` AutoChild that shows `icon`.
    `Label` | `getMessageLabel()` AutoChild that shows `message`.
    `Layout` | `getMessageStack()` AutoChild that combines `message` and `icon`.
    `static Dialog` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.String` | `getSayIcon()` Icon to show in the `SC.say()` dialog.
    `java.lang.Boolean` | `getShowToolbar()` Whether to show a toolbar of buttons at the bottom of the Dialog.
    `java.lang.String` | `getStyleName()` Style of the Dialog background
    `Toolbar` | `getToolbar()` `com.smartgwt.client.types.AutoChild` of type Toolbar used to create the `toolbarButtons`.
    `java.lang.String` | `getWarnIcon()` Icon to show in the `SC.warn()` dialog.
    `void` | `setAskIcon(java.lang.String askIcon)` Icon to show in the `SC.ask()` dialog.
    `void` | `setAutoFocus(java.lang.Boolean autoFocus)` If a toolbar is showing, automatically place keyboard focus in the first button.
    `void` | `setButtons(Button... buttons)` Array of Buttons to show in the `toolbar`, if shown.
    `void` | `setConfirmIcon(java.lang.String confirmIcon)` Icon to show in the `SC.confirm()` dialog.
    `static void` | `setDefaultProperties(Dialog dialogProperties)` Class level method to set the default properties of this class.
    `void` | `setDefaultWidth(int defaultWidth)` For custom components, establishes a default width for the component.
    `void` | `setIcon(java.lang.String icon)` Icon to show in this dialog - see `message`.
    `void` | `setIconSize(int iconSize)` Size of the icon to show in this dialog.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.DialogLogicalStructure s)` Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `void` | `setMessage(java.lang.String message)` Message to show in this dialog.
    `void` | `setMessageStyle(java.lang.String messageStyle)` Style to apply to the message text shown in the center of the dialog
    `void` | `setSayIcon(java.lang.String sayIcon)` Icon to show in the `SC.say()` dialog.
    `void` | `setShowToolbar(java.lang.Boolean showToolbar)` Whether to show a toolbar of buttons at the bottom of the Dialog.
    `void` | `setStyleName(java.lang.String styleName)` Style of the Dialog background
    `void` | `setToolbarButtons(Canvas... toolbarButtons)` This is a synonym for `setButtons()`.
    `void` | `setWarnIcon(java.lang.String warnIcon)` Icon to show in the `SC.warn()` dialog.

    - ### Methods inherited from class com.smartgwt.client.widgets.Window

      `addCloseClickHandler, addItem, addItem, addMaximizeClickHandler, addMember, addMember, addMinimizeClickHandler, addRestoreClickHandler, centerInPage, close, flash, getAnimateMinimize, getAutoCenter, getAutoSize, getBody, getBodyColor, getBodyStyle, getBringToFrontOnMouseUp, getCanDragReposition, getCanDragResize, getCanFocusInHeaderButtons, getCloseButton, getContentLayout, getContentsType, getDefaultMinimizeHeight, getDismissOnEscape, getDismissOnOutsideClick, getEditProxyConstructor, getFillSpaceStyleName, getFooter, getFooterHeight, getHeader, getHeaderBackground, getHeaderIcon, getHeaderLabel, getHeaderSrc, getHeaderStyle, getHiliteBodyColor, getHiliteHeaderSrc, getHiliteHeaderStyle, getIsModal, getItems, getMaximizeButton, getMaximized, getMinimizeAcceleration, getMinimizeButton, getMinimized, getMinimizeHeight, getMinimizeTime, getModalMask, getModalMaskOpacity, getModalMaskStyle, getOpacity, getPlacement, getPrintBodyStyle, getPrintHeaderStyle, getResizeFrom, getResizer, getRestoreButton, getShowBody, getShowCloseButton, getShowEdges, getShowFooter, getShowHeader, getShowHeaderBackground, getShowHeaderIcon, getShowMaximizeButton, getShowMinimizeButton, getShowModalMask, getShowResizer, getShowShadow, getShowStatusBar, getShowTitle, getSrc, getStatus, getStatusBar, getTitle, getUseBackMask, maximize, minimize, preloadImages, removeItem, restore, revealChild, revealChild, setAnimateMinimize, setAutoCenter, setAutoSize, setBodyColor, setBodyDefaults, setBodyStyle, setBringToFrontOnMouseUp, setCanDragReposition, setCanDragResize, setCanFocusInHeaderButtons, setContentLayout, setContentLayout, setContentsType, setDefaultMinimizeHeight, setDefaultProperties, setDismissOnEscape, setDismissOnOutsideClick, setEditProxyConstructor, setFillSpaceStyleName, setFooterControls, setFooterHeight, setHeaderControls, setHeaderIcon, setHeaderIcon, setHeaderIconDefaults, setHeaderIconProperties, setHeaderSrc, setHeaderStyle, setHiliteBodyColor, setHiliteHeaderSrc, setHiliteHeaderStyle, setIsModal, setKeepInParentRect, setKeepInParentRect, setLogicalStructure, setMaximized, setMinimizeAcceleration, setMinimized, setMinimizeHeight, setMinimizeTime, setModalMaskOpacity, setModalMaskStyle, setOpacity, setPlacement, setPrintBodyStyle, setPrintHeaderStyle, setResizeFrom, setShowBody, setShowCloseButton, setShowEdges, setShowFooter, setShowHeader, setShowHeaderBackground, setShowHeaderIcon, setShowMaximizeButton, setShowMinimizeButton, setShowModalMask, setShowResizer, setShowShadow, setShowStatusBar, setShowTitle, setSrc, setStatus, setTitle, setUseBackMask, shouldDismissOnEscape`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getChildTabPosition, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutEndMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutStartMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersLength, getMembersMargin, getMinMemberLength, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit_Layout, onInit, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutEndMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutStartMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinBreadthMember, setMinBreadthMember, setMinBreadthMember, setMinMemberLength, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClearHandler, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addRuleContextChangedHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clearExplicitTabIndex, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, encloses, focus, focusAfterGroup, focusAtEnd, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAdaptiveHeightPriority, getAdaptiveWidthPriority, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideEffect, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoMaskComponents, getAutoParent, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanAdaptHeight, getCanAdaptWidth, getCanDrag, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCorrectZoomOverflow, getCursor, getDataPath, getDefaultHeight, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragMaxHeight, getDragMaxWidth, getDragMinHeight, getDragMinWidth, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEnableWhen, getEndLine, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverAutoFitMaxWidth, getHoverAutoFitMaxWidthAsString, getHoverAutoFitWidth, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsRuleScope, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeavePageSpace, getLeft, getLeftAsString, getLocalId, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMaxZoomOverflowError, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPaletteDefaults, getPanelContainer, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRect, getRedrawOnResize, getResizeBarTarget, getRight, getRuleContext, getRuleContext, getRuleScope, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowColor, getShadowDepth, getShadowHOffset, getShadowImage, getShadowOffset, getShadowSoftness, getShadowSpread, getShadowVOffset, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowHover, getShowHoverComponents, getShowResizeBar, getShowSnapGrid, getShrinkElementOnHide, getSizeMayChangeOnRedraw, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStartLine, getTabIndex, getTestInstance, getTooltip, getTop, getTopAsString, getTopElement, getUpdateTabPositionOnDraw, getUpdateTabPositionOnReparent, getUseCSSShadow, getUseDragMask, getUseImageForSVG, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getValuesManagerAsString, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWhen, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, printComponents, provideRuleContext, provideRuleContext, redraw, redraw, removeChild, removeChild, removePeer, removePeer, removeSnapAlignCandidate, resizeAutoChildAttributes, resizeBy, resizeControls, resizeFonts, resizeFonts, resizeFonts, resizeIcons, resizeTo, resizeTo, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAdaptHeightByCustomizer, setAdaptiveHeightPriority, setAdaptiveWidthPriority, setAdaptWidthByCustomizer, setAllowExternalFilters, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideEffect, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoMaskComponents, setAutoParent, setAutoResizeAutoChildAttributes, setAutoResizeIcons, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanAdaptHeight, setCanAdaptWidth, setCanDrag, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCorrectZoomOverflow, setCursor, setDataPath, setDefaultHeight, setDefaultPageSpace, setDefaultProperties, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragMaxHeight, setDragMaxWidth, setDragMinHeight, setDragMinWidth, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setEnableWhen, setEndLine, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverAutoFitMaxWidth, setHoverAutoFitMaxWidth, setHoverAutoFitWidth, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsRuleScope, setIsSnapAlignCandidate, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeavePageSpace, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMaxZoomOverflowError, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setPadding, setPageLeft, setPageTop, setPanelContainer, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setRect, setRect, setRedrawOnResize, setRelativeTabPosition, setResizeBarTarget, setResizeFrom, setRight, setRuleScope, setScrollbarConstructor, setScrollbarSize, setShadowColor, setShadowDepth, setShadowHOffset, setShadowImage, setShadowOffset, setShadowSoftness, setShadowSpread, setShadowVOffset, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowHover, setShowHoverComponents, setShowResizeBar, setShowSnapGrid, setShrinkElementOnHide, setSizeMayChangeOnRedraw, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStartLine, setTabIndex, setTooltip, setTop, setTop, setUpdateTabPositionOnDraw, setUpdateTabPositionOnReparent, setUseCSSShadow, setUseDragMask, setUseImageForSVG, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setValuesManager, setVisibility, setVisible, setVisibleWhen, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateChildTabPosition, updateChildTabPositions, updateEditNode, updateHover, updateHover, updateShadow, updateTabPositionForDraw, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, applyFactoryProperties, completeCreation, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isDrawn, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDefaultProperties, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Field Detail

    - #### OK

          public static Button OK

      OK Button object. To handle click use `addButtonClickHandler` method.

    - #### APPLY

          public static Button APPLY

      APPLY Button object. To handle click use `addButtonClickHandler` method.

    - #### YES

          public static Button YES

      YES Button object. To handle click use `addButtonClickHandler` method.

    - #### NO

          public static Button NO

      NO Button object. To handle click use `addButtonClickHandler` method.

    - #### CANCEL

          public static Button CANCEL

      CANCEL Button object. To handle click use `addButtonClickHandler` method.

    - #### DONE

          public static Button DONE

      DONE Button object. To handle click use `addButtonClickHandler` method.

  - ### Constructor Detail

    - #### Dialog

          public Dialog()

    - #### Dialog

          public Dialog(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static Dialog getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `Window`

    - #### setAskIcon

          public void setAskIcon(java.lang.String askIcon)
                          throws java.lang.IllegalStateException

      Icon to show in the `SC.ask()` dialog.
      Parameters:
        `askIcon` - New askIcon value. Default value is "[SKIN]ask.png"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `SCImgURL`

    - #### getAskIcon

          public java.lang.String getAskIcon()

      Icon to show in the `SC.ask()` dialog.
      Returns:
        Current askIcon value. Default value is "[SKIN]ask.png"
      See Also:
        `SCImgURL`

    - #### setAutoFocus

          public void setAutoFocus(java.lang.Boolean autoFocus)
                            throws java.lang.IllegalStateException

      If a toolbar is showing, automatically place keyboard focus in the first button.
      Parameters:
        `autoFocus` - New autoFocus value. Default value is true
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getAutoFocus

          public java.lang.Boolean getAutoFocus()

      If a toolbar is showing, automatically place keyboard focus in the first button.
      Returns:
        Current autoFocus value. Default value is true
      See Also:
        `Appearance overview and related methods`

    - #### setConfirmIcon

          public void setConfirmIcon(java.lang.String confirmIcon)
                              throws java.lang.IllegalStateException

      Icon to show in the `SC.confirm()` dialog.
      Parameters:
        `confirmIcon` - New confirmIcon value. Default value is "[SKIN]confirm.png"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `SCImgURL`

    - #### getConfirmIcon

          public java.lang.String getConfirmIcon()

      Icon to show in the `SC.confirm()` dialog.
      Returns:
        Current confirmIcon value. Default value is "[SKIN]confirm.png"
      See Also:
        `SCImgURL`

    - #### setDefaultWidth

          public void setDefaultWidth(int defaultWidth)
                               throws java.lang.IllegalStateException

      Description copied from class: `Canvas`
      For custom components, establishes a default width for the component.

      For a component that should potentially be sized automatically by a Layout, set this property rather than `width` directly, because Layouts regard a width setting as an explicit size that shouldn't be changed.

      Note : This is an advanced setting

      Overrides:
        `setDefaultWidth` in class `Canvas`
      Parameters:
        `defaultWidth` - New defaultWidth value. Default value is 360
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getDefaultWidth

          public int getDefaultWidth()

      Description copied from class: `Canvas`
      For custom components, establishes a default width for the component.

      For a component that should potentially be sized automatically by a Layout, set this property rather than `width` directly, because Layouts regard a width setting as an explicit size that shouldn't be changed.

      Overrides:
        `getDefaultWidth` in class `Canvas`
      Returns:
        Current defaultWidth value. Default value is 360
      See Also:
        `Appearance overview and related methods`

    - #### setIcon

          public void setIcon(java.lang.String icon)
                       throws java.lang.IllegalStateException

      Icon to show in this dialog - see `message`.
      Parameters:
        `icon` - New icon value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `SCImgURL`

    - #### getIcon

          public java.lang.String getIcon()

      Icon to show in this dialog - see `message`.
      Returns:
        Current icon value. Default value is null
      See Also:
        `SCImgURL`

    - #### setIconSize

          public void setIconSize(int iconSize)
                           throws java.lang.IllegalStateException

      Size of the icon to show in this dialog.
      Parameters:
        `iconSize` - New iconSize value. Default value is 32
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getIconSize

          public int getIconSize()

      Size of the icon to show in this dialog.
      Returns:
        Current iconSize value. Default value is 32

    - #### setMessage

          public void setMessage(java.lang.String message)
                          throws java.lang.IllegalStateException

      Message to show in this dialog.

      If a message is set the primary purpose of the dialog will be assumed to be to show a message with buttons - auto-sizing to the message text will be enabled, and, if `icon` has also been set, the `messageLabel` and `messageIcon` AutoChildren will be created and placed together in the `messageStack` AutoChild, with the toolbar underneath as usual. If any of these behaviors are inconvenient or you want more precise control over a message and some custom widgets, start from the superclass `Window` instead, and add controls via `Window.addItem()`.

      The message string may contain "${loadingImage}", if so, the standard loading spinner will appear at that location in the text (see `loadingImageSrc`).

      The message will be styled with the `messageStyle`.

      Parameters:
        `message` - New message value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `HTMLString`

    - #### getMessage

          public java.lang.String getMessage()

      Message to show in this dialog.

      If a message is set the primary purpose of the dialog will be assumed to be to show a message with buttons - auto-sizing to the message text will be enabled, and, if `icon` has also been set, the `messageLabel` and `messageIcon` AutoChildren will be created and placed together in the `messageStack` AutoChild, with the toolbar underneath as usual. If any of these behaviors are inconvenient or you want more precise control over a message and some custom widgets, start from the superclass `Window` instead, and add controls via `Window.addItem()`.

      The message string may contain "${loadingImage}", if so, the standard loading spinner will appear at that location in the text (see `loadingImageSrc`).

      The message will be styled with the `messageStyle`.

      Returns:
        Current message value. Default value is null
      See Also:
        `HTMLString`

    - #### getMessageIcon

          public Img getMessageIcon()
                             throws java.lang.IllegalStateException

      AutoChild that shows `icon`.

      This component is an AutoChild named "messageIcon". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current messageIcon value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### getMessageLabel

          public Label getMessageLabel()
                                throws java.lang.IllegalStateException

      AutoChild that shows `message`.

      This component is an AutoChild named "messageLabel". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current messageLabel value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### getMessageStack

          public Layout getMessageStack()
                                 throws java.lang.IllegalStateException

      AutoChild that combines `message` and `icon`.

      This component is an AutoChild named "messageStack". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current messageStack value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setSayIcon

          public void setSayIcon(java.lang.String sayIcon)
                          throws java.lang.IllegalStateException

      Icon to show in the `SC.say()` dialog.
      Parameters:
        `sayIcon` - New sayIcon value. Default value is "[SKIN]say.png"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `SCImgURL`

    - #### getSayIcon

          public java.lang.String getSayIcon()

      Icon to show in the `SC.say()` dialog.
      Returns:
        Current sayIcon value. Default value is "[SKIN]say.png"
      See Also:
        `SCImgURL`

    - #### setShowToolbar

          public void setShowToolbar(java.lang.Boolean showToolbar)
                              throws java.lang.IllegalStateException

      Whether to show a toolbar of buttons at the bottom of the Dialog. Default of null will cause the value to be resolved automatically to true or false when the Dialog is first drawn according as `toolbarButtons` contains buttons or not.
      Parameters:
        `showToolbar` - New showToolbar value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `Appearance overview and related methods`

    - #### getShowToolbar

          public java.lang.Boolean getShowToolbar()

      Whether to show a toolbar of buttons at the bottom of the Dialog. Default of null will cause the value to be resolved automatically to true or false when the Dialog is first drawn according as `toolbarButtons` contains buttons or not.
      Returns:
        Current showToolbar value. Default value is null
      See Also:
        `Appearance overview and related methods`

    - #### setStyleName

          public void setStyleName(java.lang.String styleName)

      Style of the Dialog background
      Overrides:
        `setStyleName` in class `Canvas`
      Parameters:
        `styleName` - New styleName value. Default value is "dialogBackground"
      See Also:
        `CSSStyleName`, `Appearance overview and related methods`

    - #### getStyleName

          public java.lang.String getStyleName()

      Style of the Dialog background
      Overrides:
        `getStyleName` in class `Canvas`
      Returns:
        Current styleName value. Default value is "dialogBackground"
      See Also:
        `CSSStyleName`, `Appearance overview and related methods`

    - #### getToolbar

          public Toolbar getToolbar()
                             throws java.lang.IllegalStateException

      `com.smartgwt.client.types.AutoChild` of type Toolbar used to create the `toolbarButtons`.

      This component is an AutoChild named "toolbar". For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Current toolbar value. Default value is null
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setWarnIcon

          public void setWarnIcon(java.lang.String warnIcon)
                           throws java.lang.IllegalStateException

      Icon to show in the `SC.warn()` dialog.
      Parameters:
        `warnIcon` - New warnIcon value. Default value is "[SKIN]warn.png"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `SCImgURL`

    - #### getWarnIcon

          public java.lang.String getWarnIcon()

      Icon to show in the `SC.warn()` dialog.
      Returns:
        Current warnIcon value. Default value is "[SKIN]warn.png"
      See Also:
        `SCImgURL`

    - #### addButtonClickHandler

          public com.google.gwt.event.shared.HandlerRegistration addButtonClickHandler(ButtonClickHandler handler)

      Add a buttonClick handler.

      Fires when any button in this Dialog's toolbar is clicked. Default implementation does nothing.

      Specified by:
        `addButtonClickHandler` in interface `HasButtonClickHandlers`
      Parameters:
        `handler` - the buttonClick handler
      Returns:
        `HandlerRegistration` used to remove this handler

    - #### setDefaultProperties

          public static void setDefaultProperties(Dialog dialogProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `dialogProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### setToolbarButtons

          public void setToolbarButtons(Canvas... toolbarButtons)

      This is a synonym for `setButtons()`.

      Sets the array of Buttons to show in the `toolbar`, if shown.

      Note that the buttons passed to this API may either be widgets intended as live buttons, or configuration objects (as in the case of `ListGrid.setFilterButtonProperties()`). However, the safeguards present in the latter API can't be imposed here, because there's no way to tell which widgets are live objects, and which are intended for configuration. In effect, all widgets will be treated as live objects. As a result, you musn't reuse any configuration object passed to this API, which includes passing anything to thsi API that's already been passed to "real" config APIs (like the one mentioned).

      Parameters:
        `toolbarButtons` - buttons for the toolbar. Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `SGWTProperties`

    - #### setMessageStyle

          public void setMessageStyle(java.lang.String messageStyle)
                               throws java.lang.IllegalStateException

      Style to apply to the message text shown in the center of the dialog

      Note : This is an advanced setting

      Parameters:
        `messageStyle` - messageStyle Default value is "normal"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setButtons

          public void setButtons(Button... buttons)
                          throws java.lang.IllegalStateException

      Array of Buttons to show in the `toolbar`, if shown.

      The set of buttons to use is typically set by calling one of the shortcuts such as `isc.say()` or `isc.confirm()`. A custom set of buttons can be passed to these shortcuts methods via the "properties" argument, or to a directly created Dialog.

      In both cases, a mixture of `built-in buttons`, custom buttons, and other components (such as a `LayoutSpacer`) can be passed.

      Built-in buttons can be referred to via static fields on the Dialog class such as `Dialog.OK`, for example:

           Dialog dialog = new Dialog();
           Canvas layoutSpacer = new LayoutSpacer();
           layoutSpacer.setWidth(50);
           Button notNowButton = new Button("Not now");
           notNowButton.addClickHandler(new ClickHandler() {
               public void onClick(ClickEvent event) {
                   doSomething();
               }
           });
           dialog.setButtons(Dialog.OK, Dialog.CANCEL, layoutSpacer, notNowButton);
           dialog.draw();

      All buttons will fire the `Dialog.buttonClick()` handler.

      Note that the buttons passed to this API may either be widgets intended as live buttons, or configuration objects (as in the case of `ListGrid.setFilterButtonProperties()`). However, the safeguards present in the latter API can't be imposed here, because there's no way to tell which widgets are live objects, and which are intended for configuration. In effect, all widgets will be treated as live objects. As a result, you musn't reuse any configuration object passed to this API, which includes passing anything to thsi API that's already been passed to "real" config APIs (like the one mentioned).

      While any live objects that have already been instantiated at the time this call is made will become Buttons in the Dialog, uninstantiated live objects will merely be used as templates to create separate SmartGWT Button objects when the Dialog instance is created. If you need the live objects you pass in to be the ones actually returned by Dialog-related events, you can force instantiation beforehand by calling `button.completeCreation()`.

      Parameters:
        `buttons` - buttons Default value is null
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created
      See Also:
        `SGWTProperties`

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.DialogLogicalStructure s)

      Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `Window`